#include <string.h>
#include <unistd.h>
#include <errno.h>

void error(char *message) {
  write(2,message,strlen(message));
  write(2,"\n",1);
  exit(1);
}

void panic() {
  switch (errno) {
  case EPERM:
    error("permission denied");
  case EFAULT:
    error("invalid pointer");
  case ENAMETOOLONG:
    error("name too long");
  case ENOENT:
    error("file not found");
  case ENOMEM:
    error("out of virtual memory");
  case ENOTDIR:
    error("not a directory");
  case EACCES:
    error("directory search permissions denied");
  case ELOOP:
    error("too many symbolic links");
  case EIO:
    error("I/O error");
  default:
    error("unknown error");
  }
}

int main(int argc,char *argv[]) {
  int err1,err2;
  if (chroot(argv[1]) || chdir("/"))
    panic();
  execvp(argv[2],argv+2);
  panic();
}
